/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the ClonedScript type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ClonedScript{}

// ClonedScript struct for ClonedScript
type ClonedScript struct {
	Id string `json:"id"`
	ChannelId string `json:"channel_id"`
}

// NewClonedScript instantiates a new ClonedScript object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewClonedScript(id string, channelId string) *ClonedScript {
	this := ClonedScript{}
	this.Id = id
	this.ChannelId = channelId
	return &this
}

// NewClonedScriptWithDefaults instantiates a new ClonedScript object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewClonedScriptWithDefaults() *ClonedScript {
	this := ClonedScript{}
	return &this
}

// GetId returns the Id field value
func (o *ClonedScript) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *ClonedScript) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *ClonedScript) SetId(v string) {
	o.Id = v
}

// GetChannelId returns the ChannelId field value
func (o *ClonedScript) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *ClonedScript) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *ClonedScript) SetChannelId(v string) {
	o.ChannelId = v
}

func (o ClonedScript) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ClonedScript) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["channel_id"] = o.ChannelId
	return toSerialize, nil
}

type NullableClonedScript struct {
	value *ClonedScript
	isSet bool
}

func (v NullableClonedScript) Get() *ClonedScript {
	return v.value
}

func (v *NullableClonedScript) Set(val *ClonedScript) {
	v.value = val
	v.isSet = true
}

func (v NullableClonedScript) IsSet() bool {
	return v.isSet
}

func (v *NullableClonedScript) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableClonedScript(val *ClonedScript) *NullableClonedScript {
	return &NullableClonedScript{value: val, isSet: true}
}

func (v NullableClonedScript) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableClonedScript) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


